SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Utilities'!
SystemOrganization addCategory: #'Magritte-Core-Tests'!

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:44'!
realSubject
	^super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 1/1/2005 15:58'!
on: anObject
	^self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 2/28/2005 16:05'!
doesNotUnderstand: aMessage
	^self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 2/28/2005 16:05'!
isNil
	^self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printString
	^String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject
	^realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject: anObject
	realSubject := anObject! !

!UndefinedObject methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'n/a'! !

Error subclass: #MAValidation
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAValidation class methodsFor: 'instance creation' stamp: 'lr 3/13/2005 20:28'!
description: aDescription message: aString
	^self new
		tag: aDescription;
		signal: aString.! !

MAValidation subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAValidation subclass: #MAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAValidationNotification methodsFor: 'testing' stamp: 'lr 3/13/2005 17:44'!
isResumable
	^true! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:55'!
default
	default isNil
		ifTrue: [ default := self new ].
	^default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each)
				ifTrue: [ container append: (anObject perform: each) ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 3/9/2005 22:42'!
isDescriptionSelector: aSelector
	^aSelector isUnary 
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^self cache
		at: anObject
		ifAbsentPut: [ super buildFor: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 10:56'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:56'!
initialize
	super initialize.
	self flush.! !

Object subclass: #MADescription
	instanceVariableNames: 'key label priority properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer class methodsFor: 'testing' stamp: 'lr 3/10/2005 22:52'!
isConcrete
	^true! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
add: aDescription
	self remove: aDescription.
	self children add: aDescription.! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
append: anObject
	(anObject isKindOf: MADescription)
		ifTrue: [ self add: anObject ]
		ifFalse: [ 
			anObject isCollection
				ifTrue: [ self addAll: anObject ] ].! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol
	^children detect: [ :each | aSymbol = each key ].! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol ifAbsent: aBlock
	^children detect: [ :each | aSymbol = each key ] ifNone: aBlock.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
children
	^children! !

!MAContainer methodsFor: 'accessing-configuration' stamp: 'lr 3/11/2005 11:30'!
defaultChildCollection
	^OrderedCollection new.! !

!MAContainer methodsFor: 'enumeration' stamp: 'lr 3/10/2005 10:52'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:53'!
initialize
	super initialize.
	children := self defaultChildCollection.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/10/2005 10:53'!
postCopy
	super postCopy.
	children := self defaultChildCollection 
		addAll: (self children collect: [ :each | each copy ]);
		yourself.! !

!MAContainer methodsFor: 'enumeration' stamp: 'lr 3/11/2005 09:48'!
reject: aBlock
	^self select: [ :each | (aBlock value: each) not ].! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/11/2005 09:40'!
removeAll
	children := self defaultChildCollection.! !

!MAContainer methodsFor: 'enumeration' stamp: 'lr 3/11/2005 09:40'!
select: aBlock
	^self copy
		removeAll;
		addAll: (self children 
			select: aBlock);
		yourself.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPriorityContainer methodsFor: 'accessing-configuration' stamp: 'lr 3/11/2005 11:30'!
defaultChildCollection
	^SortedCollection sortBlock: [ :a :b | a priority <= b priority ].! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:17'!
defaultKey
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:27'!
defaultPriority
	^0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:23'!
defaultReadonly
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 20:39'!
defaultRequired
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	^super defaultTitle allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:28'!
defaultVisible
	^true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 11:17'!
descriptionKey
	^MASymbol key: #key label: 'Key' priority: 100 default: self defaultKey.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 11:17'!
descriptionLabel
	^MAString key: #label label: 'Label' priority: 110 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 10:29'!
descriptionPriority
	^MANumber key: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:49'!
descriptionReadonly
	^MABoolean key: #readonly label: 'Readonly' priority: 200 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/11/2005 20:32'!
descriptionRequired
	^MABoolean key: #required label: 'Required' priority: 220 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:49'!
descriptionVisible
	^MABoolean key: #visible label: 'Visible' priority: 210 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/10/2005 22:52'!
isConcrete
	^false! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey
	^self key: aKey label: aKey asString.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString
	^self key: aKey label: aString priority: self defaultPriority.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString priority: aNumber
	^self new
		key: aKey;
		label: aString;
		priority: aNumber;
		readonly: self defaultReadonly;
		visible: self defaultVisible;
		yourself.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/9/2005 18:29'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isConcrete
		ifFalse: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:31'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:25'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'initialize-release' stamp: 'lr 3/9/2005 17:58'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isReadonly
	^self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/11/2005 20:31'!
isRequired
	^self required.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isVisible
	^self visible.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key
	^key! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key: anObject
	key := anObject! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label
	^label! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label: aString
	label := aString! !

!MADescription methodsFor: 'copying' stamp: 'lr 3/10/2005 10:54'!
postCopy
	super postCopy.
	properties := properties copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 3/10/2005 10:50'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' key: '; print: self key.
	aStream nextPutAll: ' label: '; print: self label.
	aStream nextPutAll: ' priority: '; print: self priority.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:09'!
priority
	^priority! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:09'!
priority: aNumber
	priority := aNumber! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
properties
	^properties! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyAt: aKey
	^self properties at: aKey.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey put: aValue
	self properties at: aKey put: aValue.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyIncludes: aKey
	^self properties includesKey: aKey.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
readonly	
	^self 
		propertyAt: #readonly 
		ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 20:24'!
required	
	^self 
		propertyAt: #required 
		ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 20:24'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
visible	
	^self 
		propertyAt: #visible 
		ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElement
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElement subclass: #MABinary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABinary class methodsFor: 'testing' stamp: 'lr 3/10/2005 10:35'!
isConcrete
	^true! !

!MABinary methodsFor: 'testing' stamp: 'lr 3/11/2005 22:03'!
includes: anObject
	^anObject isKindOf: ByteArray.! !

!MABinary methodsFor: 'converting' stamp: 'lr 3/11/2005 21:28'!
parseString: aString
	^[ aString asByteArray ]
		on: Error
		do: [ :err | err return: aString ].! !

MAElement subclass: #MABoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABoolean class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:48'!
defaultDefault
	^false! !

!MABoolean class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 22:44'!
defaultOptions
	^Array with: true with: false.! !

!MABoolean class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MABoolean methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABoolean methodsFor: 'testing' stamp: 'lr 3/11/2005 21:41'!
includes: anObject
	^anObject isKindOf: Boolean.! !

!MABoolean methodsFor: 'converting' stamp: 'lr 3/11/2005 21:39'!
parseString: aString
	(self trueStrings includes: aString)
		ifTrue: [ ^true ].
	(self falseStrings includes: aString)
		ifTrue: [ ^false ].
	^aString.! !

!MABoolean methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

MAElement subclass: #MADate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADate class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MADate methodsFor: 'testing' stamp: 'lr 3/11/2005 21:33'!
includes: anObject
	^anObject isKindOf: Date.! !

!MADate methodsFor: 'converting' stamp: 'lr 3/11/2005 21:28'!
parseString: aString
	^[ Date fromString: aString ]
		on: Error
		do: [ :err | err return: aString ].! !

!MAElement class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 14:43'!
defaultDefault
	^nil! !

!MAElement class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:50'!
descriptionDefault
	^self isConcrete 
		ifTrue: [ self key: #default label: 'Default' priority: 130 default: self defaultDefault ].! !

!MAElement class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber
	^(super key: aKey label: aString priority: aNumber)
		default: self defaultDefault;
		yourself.! !

!MAElement class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber default: aValue
	^(self key: aKey label: aString priority: aNumber)
		default: aValue;
		yourself.! !

!MAElement methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:08'!
default
	^default! !

!MAElement methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:08'!
default: anObject
	default := anObject! !

!MAElement methodsFor: 'private' stamp: 'lr 3/11/2005 20:38'!
errorReadonly
	self error: self label , ' is readonly.'.! !

!MAElement methodsFor: 'private' stamp: 'lr 3/11/2005 20:38'!
errorRequired
	self error: self label , ' is required.'.! !

!MAElement methodsFor: 'testing' stamp: 'lr 3/11/2005 21:32'!
includes: anObject
	self subclassResponsibility.! !

!MAElement methodsFor: 'converting' stamp: 'lr 3/11/2005 21:10'!
migrate: anObject from: aDescription
	^self parseString: (aDescription toString: anObject).! !

!MAElement methodsFor: 'converting' stamp: 'lr 3/11/2005 21:45'!
parseString: aString
	self subclassResponsibility.! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 10:46'!
read: aModel
	"Read from aModel using the receiver as description."
	
	^(aModel readUsing: self)
		ifNil: [ self default ].! !

!MAElement methodsFor: 'private' stamp: 'lr 3/10/2005 15:53'!
readSelector	
	^self key asSymbol.! !

!MAElement methodsFor: 'converting' stamp: 'lr 3/13/2005 20:51'!
toString: anObject
	^anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asString ].! !

!MAElement methodsFor: 'testing' stamp: 'lr 3/13/2005 20:00'!
validates: anObject
	^self isRequired
		ifTrue: [ self includes: anObject ]
		ifFalse: [ anObject isNil or: [ self includes: anObject ] ].! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/11/2005 22:54'!
write: anObject to: aModel
	"Write to aModel using the receiver as description and anObject as value."

	self isReadonly 
		ifTrue: [ self errorReadonly ].
	(self isRequired and: [ anObject isNil ])
		 ifTrue: [ self errorRequired ].
	^aModel write: anObject using: self.! !

!MAElement methodsFor: 'private' stamp: 'lr 3/10/2005 15:53'!
writeSelector	
	^(self key copyWith: $:) 
		asSymbol.! !

MAElement subclass: #MANumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumber class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MANumber methodsFor: 'testing' stamp: 'lr 3/11/2005 21:33'!
includes: anObject
	^anObject isKindOf: Number.! !

!MANumber methodsFor: 'converting' stamp: 'lr 3/11/2005 21:28'!
parseString: aString
	^[ aString asNumber ] 
		on: Error 
		do: [ :err | err return: aString ].! !

MAElement subclass: #MAOptions
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAOptions class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 22:19'!
defaultLabelBlock
	^MAReceiverBlock selector: #asLabel.! !

!MAOptions class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 22:34'!
defaultOptions
	^OrderedCollection new! !

!MAOptions class methodsFor: 'accessing-description' stamp: 'lr 3/12/2005 12:18'!
descriptionOptions
	^MAText key: #textual label: 'Options' priority: 140.! !

!MAOptions class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:34'!
isConcrete
	^true! !

!MAOptions methodsFor: 'actions' stamp: 'lr 3/11/2005 22:42'!
addOption: anObject
	(self includes: anObject)
		ifFalse: [ self options add: anObject ].! !

!MAOptions methodsFor: 'testing' stamp: 'lr 3/11/2005 22:38'!
includes: anObject
	^self options includes: anObject.! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/11/2005 22:50'!
options
	options isNil
		ifTrue: [ self options: self class defaultOptions ].
	^options! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/11/2005 22:37'!
options: aCollection
	options := aCollection! !

!MAOptions methodsFor: 'converting' stamp: 'lr 3/11/2005 22:39'!
parseString: aString
	^aString! !

!MAOptions methodsFor: 'copying' stamp: 'lr 3/11/2005 22:36'!
postCopy
	super postCopy.
	self options: self options copy.! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/12/2005 12:18'!
textual
	^Array streamContents: [ :stream |
		self options
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream cr ] ].! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/12/2005 12:18'!
textual: aString
	self options: (aString findTokens: Character cr).! !

MAElement subclass: #MAString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAString subclass: #MAPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPassword methodsFor: 'converting' stamp: 'lr 3/11/2005 21:46'!
obfuscated: aString
	^aString isEmptyOrNil
		ifFalse: [ Array new: aString size withAll: $* ].! !

!MAString class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MAString methodsFor: 'testing' stamp: 'lr 3/11/2005 21:34'!
includes: anObject
	^anObject isKindOf: String.! !

!MAString methodsFor: 'converting' stamp: 'lr 3/11/2005 21:45'!
parseString: aString
	^aString isEmptyOrNil
		ifFalse: [ aString ].! !

MAString subclass: #MASymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbol methodsFor: 'testing' stamp: 'lr 3/11/2005 21:34'!
includes: anObject
	^anObject isKindOf: Symbol.! !

!MASymbol methodsFor: 'converting' stamp: 'lr 3/11/2005 21:29'!
parseString: aString
	^[ aString asSymbol ]
		on: Error
		do: [ :err | err return: aString ].! !

MAString subclass: #MAText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElement subclass: #MATime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATime class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:15'!
isConcrete
	^true! !

!MATime methodsFor: 'testing' stamp: 'lr 3/11/2005 21:34'!
includes: anObject
	^anObject isKindOf: Time.! !

!MATime methodsFor: 'converting' stamp: 'lr 3/11/2005 21:28'!
parseString: aString
	^[ Time fromString: aString ]
		on: Error
		do: [ :err | err return: aString ].! !

MAElement subclass: #MATimeStamp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeStamp class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:11'!
isConcrete
	^true! !

!MATimeStamp methodsFor: 'testing' stamp: 'lr 3/11/2005 21:35'!
includes: anObject
	^anObject isKindOf: TimeStamp.! !

!MATimeStamp methodsFor: 'converting' stamp: 'lr 3/11/2005 21:35'!
parseString: aString
	^[ TimeStamp fromString: aString ]
		on: Error
		do: [ :err | err return: aString ].! !

Object subclass: #MAMockModel
	instanceVariableNames: 'values description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAMockModel class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 14:46'!
descriptionBinary
	^MADate key: #date label: 'Date'.! !

!MAMockModel class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 14:47'!
descriptionDate
	^MADate key: #date! !

!MAMockModel class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 14:46'!
descriptionTime
	^MATime key: #time! !

!MAMockModel methodsFor: 'private' stamp: 'lr 3/10/2005 22:54'!
buildDescription
	^self class description copy in: [ :container |
		MAElement allSubclassesDo: [ :class |
			class isConcrete ifTrue: [ 
				container add: (class key: class description label asLowercase asSymbol) ] ].
		container ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 14:57'!
description
	description isNil
		ifTrue: [ description := self buildDescription ].
	^description.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
readUsing: aDescription
	^self values 
		at: aDescription key 
		ifAbsent: [ nil ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 16:54'!
values
	values isNil
		ifTrue: [ values := Dictionary new ].
	^values.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
write: anObject using: aDescription
	self values 
		at: aDescription key
		put: anObject.! !

Object subclass: #MAReceiverBlock
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAReceiverBlock class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 22:17'!
selector: aSelector
	^self new
		selector: aSelector;
		yourself.! !

!MAReceiverBlock methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:16'!
selector	
	^selector! !

!MAReceiverBlock methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:16'!
selector: aSelector
	selector := aSelector! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:15'!
value
	self shouldNotImplement.! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:17'!
value: aReceiver
	^aReceiver perform: self selector.! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:17'!
value: aReceiver value: anObject
	^aReceiver perform: self selector with: anObject.! !

!MAReceiverBlock methodsFor: 'evaluation' stamp: 'lr 3/10/2005 22:18'!
value: aReceiver value: anObject value: anotherObject
	^aReceiver perform: self selector with: anObject with: anotherObject.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/11/2005 11:31'!
defaultContainer
	"Return the default description container."
	
	^MAPriorityContainer
		key: #yourself
		label: self defaultTitle.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	"Return the title of this class to be used in the description."
	
	^self name asString.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:38'!
description
	^MACachedBuilder default buildFor: self.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:20'!
asLabel
	^self asString.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:39'!
readUsing: aDescription
	^self perform: aDescription readSelector.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:48'!
write: anObject using: aDescription
	self perform: aDescription writeSelector with: anObject.! !

!False methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'no'! !

!True methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'yes'! !

TestCase subclass: #MAAbstractTest
	instanceVariableNames: 'value other description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAAbstractTest subclass: #MAAbstractElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/11/2005 21:51'!
testIncludes
	self subclassResponsibility.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/11/2005 21:52'!
testParseString
	self subclassResponsibility.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/11/2005 22:55'!
testRead
	self value: (other := Object new).
	self assert: (description read: self) = other.! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/11/2005 23:01'!
testReadonly
	description beReadonly.
	self assert: description isReadonly.
	self should: [ description write: Object new to: self ] raise: Error.
	self assert: self value isNil.
	
	description beWriteable.
	self deny: description isReadonly.
	self shouldnt: [ description write: Object new to: self ] raise: Error.
	self assert: self value notNil.! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/11/2005 23:02'!
testRequired
	description beRequired.
	self assert: description isRequired.
	self should: [ description write: nil to: self ] raise: Error.
	self assert: self value isNil.
	self shouldnt: [ description write: 'abc' to: self ] raise: Error.
	self assert: self value = 'abc'.
	
	description beOptional.
	self deny: description isRequired.
	self shouldnt: [ description write: nil to: self ] raise: Error.
	self assert: self value isNil.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:43'!
testToString
	self assert: (description toString: 'abc') = 'abc'.! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/11/2005 22:59'!
testVisible
	description beVisible.
	self assert: description isVisible.
	
	description beHidden.
	self deny: description isVisible.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/11/2005 22:56'!
testWrite
	description write: (other := Object new) to: self.
	self assert: self value = other.! !

MAAbstractElementTest subclass: #MABinaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:57'!
descriptionClass
	^MABinary! !

!MABinaryTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:03'!
testIncludes
	self assert: (description includes: (ByteArray new)).
	self assert: (description includes: (ByteArray with: 97 with: 98 with: 99)).
	
	self deny: (description includes: 'true').
	self deny: (description includes: 123).
	self deny: (description includes: nil).! !

!MABinaryTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:29'!
testParseString
	self assert: (description parseString: 'abc') = (ByteArray with: 97 with: 98 with: 99).
	self assert: (description parseString: nil) = nil.! !

MAAbstractElementTest subclass: #MABooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:52'!
descriptionClass
	^MABoolean! !

!MABooleanTest methodsFor: 'testing' stamp: 'lr 3/11/2005 21:53'!
testIncludes
	self assert: (description includes: true).
	self assert: (description includes: false).
	
	self deny: (description includes: 'true').
	self deny: (description includes: 123).! !

!MABooleanTest methodsFor: 'testing' stamp: 'lr 3/11/2005 21:55'!
testParseString
	self assert: (description parseString: 'true') = true.
	self assert: (description parseString: 'yes') = true.
	self assert: (description parseString: 'on') = true.
	
	self assert: (description parseString: 'false') = false.
	self assert: (description parseString: 'no') = false.
	self assert: (description parseString: 'off') = false.
	
	self assert: (description parseString: 'abc') = 'abc'.
	self assert: (description parseString: nil) = nil.! !

MAAbstractElementTest subclass: #MADateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADateTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:57'!
descriptionClass
	^MADate! !

!MADateTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:07'!
testIncludes
	self assert: (description includes: Date current).
	self assert: (description includes: Date tomorrow).
	
	self deny: (description includes: Time current).
	self deny: (description includes: 'true').
	self deny: (description includes: 123).
	self deny: (description includes: nil).! !

!MADateTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:31'!
testParseString
	self assert: (description parseString: '11 March 2005') = (Date year: 2005 month: 3 day: 11).
	self assert: (description parseString: 'March, 11 2005') = (Date year: 2005 month: 3 day: 11).
	self assert: (description parseString: '3/11/05') = (Date year: 2005 month: 3 day: 11).
	
	self assert: (description parseString: nil) = nil.! !

MAAbstractElementTest subclass: #MANumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MANumberTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:57'!
descriptionClass
	^MANumber! !

!MANumberTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:06'!
testIncludes
	self assert: (description includes: 123).
	self assert: (description includes: 123.123).
	
	self deny: (description includes: 'abc').
	self deny: (description includes: nil).! !

!MANumberTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:29'!
testParseString
	self assert: (description parseString: '123') = 123.
	self assert: (description parseString: '123.123') = 123.123.
	
	self assert: (description parseString: nil) = nil.! !

MAAbstractElementTest subclass: #MAOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:33'!
descriptionClass
	^MAOptions! !

!MAOptionsTest methodsFor: 'running' stamp: 'lr 3/11/2005 22:48'!
setUp
	super setUp.
	description 
		addOption: 1; 
		addOption: 2; 
		addOption: 3.! !

!MAOptionsTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:49'!
testIncludes
	self assert: (description includes: 1).
	self assert: (description includes: 2).
	
	self deny: (description includes: '1').
	self deny: (description includes: 4).
	self deny: (description includes: nil).! !

!MAOptionsTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:51'!
testParseString
	self assert: (description parseString: 'abc') = 'abc'.
	self assert: (description parseString: nil) = nil.! !

MAAbstractElementTest subclass: #MAStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAStringTest subclass: #MAPasswordTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAPasswordTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:07'!
descriptionClass
	^MAPassword! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:07'!
descriptionClass
	^MAString! !

!MAStringTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:12'!
testIncludes
	self assert: (description includes: 'abc').
	self assert: (description includes: '').
	
	self deny: (description includes: Date current).
	self deny: (description includes: 123).
	self deny: (description includes: nil).! !

!MAStringTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:29'!
testParseString
	self assert: (description parseString: 'abc') = 'abc'.
	self assert: (description parseString: nil) = nil.! !

MAStringTest subclass: #MASymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:08'!
descriptionClass
	^MASymbol! !

!MASymbolTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:13'!
testIncludes
	self assert: (description includes: #abc).
	self assert: (description includes: #'abc').
	
	self deny: (description includes: Date current).
	self deny: (description includes: 'abc').
	self deny: (description includes: 123).
	self deny: (description includes: nil).! !

!MASymbolTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:29'!
testParseString
	self assert: (description parseString: #abc) = 'abc'.
	self assert: (description parseString: nil) = nil.! !

MAStringTest subclass: #MATextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATextTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:08'!
descriptionClass
	^MAText! !

MAAbstractElementTest subclass: #MATimeStampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:08'!
descriptionClass
	^MATimeStamp! !

!MATimeStampTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:09'!
testIncludes
	self assert: (description includes: TimeStamp current).
	self assert: (description includes: TimeStamp noon).
	
	self deny: (description includes: Date current).
	self deny: (description includes: 'true').
	self deny: (description includes: 123).
	self deny: (description includes: nil).! !

!MATimeStampTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:29'!
testParseString
	self assert: (description parseString: '11 March 2005 22:27') = (TimeStamp year: 2005 month: 3 day: 11 hour: 22 minute: 27).
	self assert: (description parseString: '11 March 2005 10:27:28 pm') = (TimeStamp year: 2005 month: 3 day: 11 hour: 22 minute: 27 second: 28).
	
	self assert: (description parseString: nil) = nil.! !

MAAbstractElementTest subclass: #MATimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:09'!
descriptionClass
	^MATime! !

!MATimeTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:09'!
testIncludes
	self assert: (description includes: Time current).
	self assert: (description includes: Time noon).
	
	self deny: (description includes: Date current).
	self deny: (description includes: 'true').
	self deny: (description includes: 123).
	self deny: (description includes: nil).! !

!MATimeTest methodsFor: 'testing' stamp: 'lr 3/11/2005 22:29'!
testParseString
	self assert: (description parseString: '10:25:03 pm') = (Time hour: 22 minute: 25 second: 03).
	self assert: (description parseString: '22:25:03') = (Time hour: 22 minute: 25 second: 03).
	self assert: (description parseString: '22:25') = (Time hour: 22 minute: 25 second: 00).

	self assert: (description parseString: nil) = nil.! !

!MAAbstractTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:46'!
isAbstract
	^super isAbstract
		or: [ self name includesSubString: 'Abstract' ].! !

!MAAbstractTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:47'!
shouldInheritSelectors
	^true! !

!MAAbstractTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:48'!
descriptionClass
	self subclassResponsibility.! !

!MAAbstractTest methodsFor: 'running' stamp: 'lr 3/11/2005 21:49'!
setUp
	description := self descriptionClass key: #value.! !

!MAAbstractTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value
	^value! !

!MAAbstractTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value: anObject
	value := anObject! !

TestCase subclass: #MAUtitliesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!
